Package: pci
Title: A Collection of Process Capability Index Functions
Version: 1.0.1
Authors@R: 
    person("Sam", "Semegne", email = "sam.ahoi@hotmail.com", role = c("aut", "cre"))
Maintainer: Sam Semegne <sam.ahoi@hotmail.com>
Description: 
  A collection of process capability index functions, such as
  C_p(), C_pk(), C_pm(), and others, along with metadata about each, like
  'LaTeX' equations and 'R' expressions. Its primary purpose is to form a
  foundation for other quality control packages to build on top of, by providing
  basic resources and functions. The indices belong to the field of statistical
  quality control, and quantify the degree to which a manufacturing process is
  able to create items that adhere to a certain standard of quality. For details
  see Montgomery, D. C. (2019, ISBN:978-1-119-39930-8).
License: GPL-3
Encoding: UTF-8
RoxygenNote: 7.3.1
Imports: vek (>= 1.0.0)
Depends: R (>= 4.0.0)
LazyData: true
Suggests: tinytest (>= 1.4.1), devtools (>= 2.4.5)
URL: https://github.com/samsemegne/pci
NeedsCompilation: no
Packaged: 2024-06-14 23:26:00 UTC; Sam
Author: Sam Semegne [aut, cre]
Repository: CRAN
Date/Publication: 2024-06-15 00:30:06 UTC
Built: R 4.6.0; ; 2026-04-26 01:29:04 UTC; unix

# pci

***A Collection of Process Capability Index Functions***

## Installation
```
install.packages("pci")
```

## About
Provides a collection of process capability index functions, such as $C_p$,
$C_{pk}$, $C_{pm}$, and others, along with metadata about each, like LaTeX
equations and R expressions. Its primary purpose is to form a foundation for
other quality control packages to build on top of, by providing basic resources
and functions. The indices belong to the field of statistical quality control,
and quantify the degree to which a manufacturing process is able to create items
that adhere to a certain standard of quality. For details see Montgomery, D. C.
(2019, ISBN:978-1-119-39930-8).

**Included:**

* $C_p$
* $C_{pl}$
* $C_{pu}$
* $C_{pk}$
* $C_{pm}$

## References
* Montgomery, D. C. (2019). *Introduction to statistical quality control* (8th ed.). Wiley. ISBN: 978-1-119-39930-8

is_all_unique = function(x) {
  return(length(unique(x)) == length(x))
}


expect_ok_chr_vec = function(x) {
  expect_true(vek::is_chr_vec_nxb(x))
  expect_false(any(startsWith(x, " "), na.rm = TRUE)) # no leading spaces
  expect_false(any(endsWith(x, " "), na.rm = TRUE)) # no trailing spaces
}


grepl_ = function(pattern_, x_) {
  return(grepl(
    pattern = pattern_,
    x = x_,
    ignore.case = FALSE,
    perl = FALSE,
    fixed = FALSE,
    useBytes = FALSE
  ))
}


is_valid_r_name = function(x) {
  return(grepl_("^((([[:alpha:]]|[.][._[:alpha:]])[._[:alnum:]]*)|[.])$", x))
}


expect_true(is.data.frame(pci_info))
expect_identical(class(pci_info), "data.frame")
expect_true(ncol(pci_info) > 0L)
expect_true(nrow(pci_info) > 0L)
expect_true(length(unique(colnames(pci_info))) == ncol(pci_info))
expect_false(anyNA(colnames(pci_info), recursive = FALSE))
expect_false(any(colnames(pci_info) == "", na.rm = TRUE))


colnames_1_to_6 = c(
  "pci_id", "name_r", "name_latex", "name_r_expr", "expr_r", "eq_latex")

expect_identical(colnames(pci_info)[1:6], colnames_1_to_6) # v1.0.0 columns
rm(colnames_1_to_6)


rownames_1_to_5 = c("C_p", "C_pl", "C_pu", "C_pk", "C_pm")  # v1.0.0 rows
expect_identical(row.names(pci_info)[1:5], rownames_1_to_5)
rm(rownames_1_to_5)


# Test column 'pci_id' ---------------------------------------------------------
expect_ok_chr_vec(pci_info$pci_id)
expect_true(all(is_valid_r_name(pci_info$pci_id), na.rm = TRUE))
expect_false(any(grepl_("\\.", pci_info$pci_id), na.rm = TRUE)) # no periods
expect_false(any(endsWith(pci_info$pci_id, "_"), na.rm = TRUE))

expect_true(is_all_unique(pci_info$pci_id))

# Assert that row names equal 'pci_id' values.
expect_true(all(row.names(pci_info) == pci_info$pci_id, na.rm = FALSE))


# Test column 'name_r' ---------------------------------------------------------
expect_ok_chr_vec(pci_info$name_r)
expect_true(all(is_valid_r_name(pci_info$name_r), na.rm = TRUE))
expect_false(any(grepl_("\\.", pci_info$name_r), na.rm = TRUE)) # no periods
expect_false(any(endsWith(pci_info$name_r, "_"), na.rm = TRUE))

expect_true(is_all_unique(pci_info$name_r))


# Test column 'name_latex' -----------------------------------------------------
expect_ok_chr_vec(pci_info$name_latex)
expect_true(is_all_unique(pci_info$name_latex))


# Test column 'expr_r' ---------------------------------------------------------
expect_ok_chr_vec(pci_info$expr_r)
expect_true(is_all_unique(pci_info$expr_r))

# Assert that each character in 'expr_r' parses to a valid R expression.
for (x in pci_info$expr_r) {
  expect_true(is.expression(str2expression(x)))
}


# Test column 'eq_latex' -------------------------------------------------------
expect_ok_chr_vec(pci_info$eq_latex)
expect_true(is_all_unique(pci_info$eq_latex))


# Test column 'name_r_expr' ----------------------------------------------------
expect_ok_chr_vec(pci_info$name_r_expr)
expect_true(is_all_unique(pci_info$name_r_expr))

# Assert that each character in 'name_r_expr' parses to a valid R expression.
for (x in pci_info$name_r_expr) {
  expect_true(is.expression(str2expression(x)))
}


# Attributes column 'attributes' -----------------------------------------------
expect_identical(class(pci_info$attributes), "AsIs")
expect_identical(typeof(pci_info$attributes), "list")

for (pci_i in 1:nrow(pci_info)) {
  pci_attr = pci_info$attributes[pci_i]

  # Assert that the PCI's attribute is an unnamed list.
  expect_true(is.null(names(pci_attr)))

  for (pci_attr_entry in pci_attr) {
    # Assert that each attribute entry must is a named list.
    expect_false(is.null(names(pci_attr_entry)))
    expect_false(any(names(pci_attr_entry) == "", na.rm = FALSE))
    expect_true(is_all_unique(names(pci_attr_entry)))

    expect_true(length(pci_attr_entry) > 1L)

    # Assert that each attribute entry has a 'type' field
    expect_true("type" %in% names(pci_attr_entry))
    expect_true(names(pci_attr_entry)[[1L]] == "type")
    expect_true(vek::is_chr_vec_nxb1(pci_attr_entry$type))
  }
}

expect_error(C_pl(), 'argument "mu" is missing, with no default')
expect_error(C_pl(1.5), 'argument "sigma" is missing, with no default')
expect_error(C_pl(1.5, 1.), 'argument "lsl" is missing, with no default')
expect_error(C_pl(1.5, 1., 2.),
             'argument "l" is missing, with no default')

expect_error(C_pl(1.5, 1., 2., 3., 4.), 'unused argument \\(4\\)')
expect_error(
  C_pl("1.5", 1., 2., 3.),
  '"mu" must be a base-R numeric vector and contain no Inf values'
)

expect_error(
  C_pl(1.5, "1.", 2., 3.),
  '"sigma" must be a base-R numeric vector and contain no Inf values'
)

expect_error(
  C_pl(1.5, 1., "2.", 3.),
  '"lsl" must be a base-R numeric vector and contain no Inf values'
)

expect_error(
  C_pl(1.5, 1., 2., "3."),
  '"l" must be a base-R numeric vector and contain no Inf values'
)

expect_error(C_pl(1.5, 1:2, 2:4, 3.),
             'All vector arguments with length >1 must be of equal length')

expect_error(C_pl(1.5, -1., 2., 3.), '"sigma >= 0" is false')
expect_error(C_pl(1.5, 1., 2., 0.), '"l > 0L" is false')

expect_identical(C_pl(1.5, integer(0L), 2, 3.), double(0L)) # int yields double

# Test NA over NaN.
expect_identical(C_pl(3., 1/3, NaN, NA_real_), NA_real_)
expect_identical(C_pl(3., 1/3, NA_real_, NaN), NA_real_)

expect_identical(C_pl(3., 1/3, 2., 3.), 1.) # known output
expect_identical(C_pl(3., c(NA, 1/3), 2., 3.), c(NA, 1.)) # output with NA's
expect_identical(C_pl(3., c(NaN, 1/3), 2., 3.), c(NaN, 1.)) # output with NaN's
# sigma == 0 yields NaN.
expect_identical(C_pl(3., 0., 2., 3.), NaN)
expect_identical(C_pl(3., c(1/3, 0.), 2., 3.), c(1., NaN))


# Assert that output won't carry names attribute.
expect_identical(C_pl(c(foo = 3.), 1/3, 2., 3.), 1.)
expect_identical(C_pl(3., c(foo = 1/3), 2., 3.), 1.)
expect_identical(C_pl(3., 1/3, c(foo = 2.), 3.), 1.)
expect_identical(C_pl(3., 1/3, 2., c(foo = 3.)), 1.)


# Test pci_info$expr_r.
e = str2expression(pci_info["C_pl", "expr_r"])
args1 = list(mu = 3., sigma = 1/3, lsl = 2., l = 3.)
args2 = list(mu = 3., sigma = .314, lsl = 2., l = 3.)
expect_identical(do.call(C_pl, args1), eval(e, args1))
expect_identical(do.call(C_pl, args2), eval(e, args2))
rm(e, args1, args2)

# is_ok_lens() -----------------------------------------------------------------

# Missing args.
expect_error(pci:::is_ok_lens(), "\\.\\.\\.length\\(\\) > 0L is not TRUE")

# Positive cases.
expect_identical(pci:::is_ok_lens(integer(0L)), TRUE)
expect_identical(pci:::is_ok_lens(1L), TRUE)
expect_identical(pci:::is_ok_lens(1:3), TRUE)

expect_identical(pci:::is_ok_lens(integer(0L), 1L), TRUE)
expect_identical(pci:::is_ok_lens(integer(0L), 1:3), TRUE)
expect_identical(pci:::is_ok_lens(1L, 1:3), TRUE)
expect_identical(pci:::is_ok_lens(1:3, 1:3), TRUE)
expect_identical(pci:::is_ok_lens(1L, 1.), TRUE)
expect_identical(pci:::is_ok_lens(integer(0L), double(0L)), TRUE)

expect_identical(pci:::is_ok_lens(integer(0L), 1L, 1:3), TRUE)
expect_identical(pci:::is_ok_lens(integer(0L), 1L, 1:3, 1:3), TRUE)

expect_identical(pci:::is_ok_lens(integer(0L), 1L, 1., 1:3, double(3L)), TRUE)
expect_identical(
  pci:::is_ok_lens(integer(0L), double(0L), 1L, 1., 1:3, double(3L)),
  TRUE
)

# Negative cases.
expect_identical(pci:::is_ok_lens(integer(0L), 1L, 1:2, 1:3), FALSE)
expect_identical(pci:::is_ok_lens(1L, 1:3, 1:4), FALSE)
expect_identical(pci:::is_ok_lens(integer(0L), 1:3, 1:4), FALSE)
expect_identical(pci:::is_ok_lens(1:3, 1:4), FALSE)
expect_identical(pci:::is_ok_lens(1:3, 1:3, 1:4), FALSE)
expect_identical(pci:::is_ok_lens(1L, 1:3, 1:3, 1:4), FALSE)
expect_identical(pci:::is_ok_lens(1L, 1L, 1:3, 1:4), FALSE)
expect_identical(pci:::is_ok_lens(integer(0L), integer(0L), 1:3, 1:4), FALSE)


# is_any_len0() ----------------------------------------------------------------

# Missing args.
expect_error(pci:::is_any_len0(), "\\.\\.\\.length\\(\\) > 0L is not TRUE")

# Positive cases.
expect_identical(pci:::is_any_len0(integer(0L)), TRUE)
expect_identical(pci:::is_any_len0(integer(0L), 1L), TRUE)
expect_identical(pci:::is_any_len0(integer(0L), 1:3), TRUE)
expect_identical(pci:::is_any_len0(integer(0L), 1L, 1:3), TRUE)

# Negative cases.
expect_identical(pci:::is_any_len0(1L), FALSE)
expect_identical(pci:::is_any_len0(1:3), FALSE)
expect_identical(pci:::is_any_len0(1L, 1:3), FALSE)
expect_identical(pci:::is_any_len0(1L, 1:3, 1:4), FALSE)


# flag_na() -------------------------------------------------------------------

# Missing args.
expect_error(pci:::flag_na(), "\\.\\.\\.length\\(\\) > 0L is not TRUE")
# Not numeric vectors.
expect_error(pci:::flag_na("1."), "all\\(is_num_vec_, na.rm = FALSE\\)")
expect_error(pci:::flag_na("1.", 1.), "all\\(is_num_vec_, na.rm = FALSE\\)")
# Bad lengths.
expect_error(pci:::flag_na(1:2, 1:3),
             "do.call\\(is_ok_lens, dots\\) is not TRUE")

expect_identical(pci:::flag_na(integer(0L)), logical(0L))
expect_identical(pci:::flag_na(1L), FALSE)
expect_identical(pci:::flag_na(1:3), rep_len(FALSE, 3L))

expect_identical(pci:::flag_na(integer(0L), 1L), logical(0L))
expect_identical(pci:::flag_na(integer(0L), 1:3), logical(0L))
expect_identical(pci:::flag_na(integer(0L), 1L, 1:3), logical(0L))

expect_identical(pci:::flag_na(integer(0L), 1L, NA_integer_), logical(0L))
expect_identical(pci:::flag_na(integer(0L), 1:3, NA_integer_), logical(0L))
expect_identical(pci:::flag_na(integer(0L), 1L, 1:3, NA_integer_), logical(0L))

expect_identical(pci:::flag_na(integer(0L), 1L, rep_len(NA_integer_, 3L)),
                 logical(0L))

expect_identical(pci:::flag_na(integer(0L), 1:3, rep_len(NA_integer_, 3L)),
                 logical(0L))

expect_identical(pci:::flag_na(integer(0L), 1L, 1:3, rep_len(NA_integer_, 3L)),
                 logical(0L))

expect_identical(pci:::flag_na(NA_integer_), TRUE)
expect_identical(pci:::flag_na(c(NA_integer_, NA_integer_)), c(TRUE, TRUE))
expect_identical(pci:::flag_na(NA_integer_, 1:2), c(TRUE, TRUE))
expect_identical(pci:::flag_na(1L, c(NA_integer_, NA_integer_)), c(TRUE, TRUE))

expect_identical(pci:::flag_na(NaN), FALSE)
expect_identical(pci:::flag_na(c(NaN, NaN)), c(FALSE, FALSE))
expect_identical(pci:::flag_na(NaN, 1:2), c(FALSE, FALSE))
expect_identical(pci:::flag_na(1L, c(NaN, NaN)), c(FALSE, FALSE))

expect_identical(pci:::flag_na(c(NaN, NA_integer_)), c(FALSE, TRUE))
expect_identical(pci:::flag_na(NaN, 1:2, NA_integer_), c(TRUE, TRUE))
expect_identical(pci:::flag_na(1L, c(NaN, NaN), NA_integer_), c(TRUE, TRUE))

expect_identical(pci:::flag_na(NaN, c(1L, NA_integer_, 3L)),
                 c(FALSE, TRUE, FALSE))

expect_identical(pci:::flag_na(
  1L, c(NA_integer_, NaN, NA_integer_, NaN, NA_integer_)),
  c(TRUE, FALSE, TRUE, FALSE, TRUE)
)

expect_identical(pci:::flag_na(1L, c(NaN, NA_integer_, NaN, NA_integer_, NaN)),
                 c(FALSE, TRUE, FALSE, TRUE, FALSE))

# With NA_real_.
expect_identical(pci:::flag_na(NA_real_), TRUE)
expect_identical(pci:::flag_na(c(NA_real_, NA_real_)), c(TRUE, TRUE))
expect_identical(pci:::flag_na(NA_real_, 1:2), c(TRUE, TRUE))
expect_identical(pci:::flag_na(1L, c(NA_real_, NA_real_)), c(TRUE, TRUE))

# With named vectors.
named_len0 = integer(0L)
names(named_len0) = character(0L)
expect_identical(pci:::flag_na(named_len0), logical(0L))
rm(named_len0)

expect_identical(pci:::flag_na(c(foo = 1L)), FALSE)
expect_identical(pci:::flag_na(c(foo = 1L, bar = 2L, baz = 3L)),
                 rep_len(FALSE, 3L))

expect_identical(pci:::flag_na(c(foo = NA_integer_)), TRUE)
expect_identical(pci:::flag_na(c(foo = NA_integer_, bar = NA_integer_)),
                 c(TRUE, TRUE))

expect_identical(pci:::flag_na(c(foo = NA_integer_), c(bar = 1L, baz = 2L)),
                 c(TRUE, TRUE))

expect_identical(pci:::flag_na(
  c(foo = 1L), c(bar = NA_integer_, baz = NA_integer_)),
  c(TRUE, TRUE)
)

expect_error(C_p(), 'argument "sigma" is missing, with no default')
expect_error(C_p(1.), 'argument "lsl" is missing, with no default')
expect_error(C_p(1., 2.), 'argument "usl" is missing, with no default')
expect_error(C_p(1., 2., 3.),
             'argument "dl" is missing, with no default')

expect_error(C_p(1., 2., 3., 6., 7.), 'unused argument \\(7\\)')

expect_error(
  C_p("1..", 2., 3., 6.),
  '"sigma" must be a base-R numeric vector and contain no Inf values'
)

expect_error(
  C_p(1., "2.", 3., 6.),
  '"lsl" must be a base-R numeric vector and contain no Inf values'
)

expect_error(
  C_p(1., 2., "3.", 6.),
  '"usl" must be a base-R numeric vector and contain no Inf values'
)

expect_error(
  C_p(1., 2., 3., "6."),
  '"dl" must be a base-R numeric vector and contain no Inf values'
)

expect_error(
  C_p(1., 2:3, 3:5, 6.),
  'All vector arguments with length >1 must be of equal length'
)

expect_error(C_p(-1., 2., 3., 6.), '"sigma >= 0" is false')
expect_error(C_p(1., 3., 2., 6.), '"usl > lsl" is false')
expect_error(C_p(1., 2., 2., 6.), '"usl > lsl" is false')
expect_error(C_p(1., 2., 3., 0.), '"dl > 0" is false')

expect_identical(C_p(integer(0L), 2., 3., 6.), double(0L)) # int yields double

# Test NA over NaN.
expect_identical(C_p(1/6, 1., NaN, NA_real_), NA_real_)
expect_identical(C_p(1/6, 1., c(NaN, 2.), c(NA, 6.)), c(NA_real_, 1.))
expect_identical(C_p(1/6, c(1., 1.), NaN, NA_real_), c(NA_real_, NA_real_))
expect_identical(C_p(1/6, 1., NA_real_, NaN), NA_real_)
expect_identical(C_p(1/6, 1., c(NA_real_, 2.), c(NaN, 6.)), c(NA_real_, 1.))
expect_identical(C_p(1/6, c(1., 1.), NA_real_, NaN), c(NA_real_, NA_real_))

expect_identical(C_p(1/6, 1., 2., 6.), 1.) # known output
expect_identical(C_p(c(NA, 1/6), 1., 2., 6.), c(NA, 1.)) # output with NA's
expect_identical(C_p(c(NaN, 1/6), 1., 2., 6.), c(NaN, 1.)) # output with NaN's
# sigma == 0 yields NaN.
expect_identical(C_p(0., 1., 2., 6.), NaN)
expect_identical(C_p(c(0., 1/6), 1., 2., 6.), c(NaN, 1.))


# Assert that output won't carry names attribute.
expect_identical(C_p(c(foo = 1/6), 1., 2., 6.), 1.)
expect_identical(C_p(1/6, c(foo = 1.), 2., 6.), 1.)
expect_identical(C_p(1/6, 1., c(foo = 2.), 6.), 1.)
expect_identical(C_p(1/6, 1., 2., c(foo = 6.)), 1.)


# Test known relations to other PCI's.
expect_identical(
  C_p(1/6, 1., 2., 6.),
  (C_pl(1.5, 1/6, 1., 3.) + C_pu(1.5, 1/6, 2., 3.)) / 2.
)

expect_identical(
  C_p(.314, 1., 2., 6.),
  (C_pl(1.5, .314, 1., 3.) + C_pu(1.5, .314, 2., 3.)) / 2.
)


# Test pci_info$expr_r.
e = str2expression(pci_info["C_p", "expr_r"])
args1 = list(sigma = 1/6, lsl = 1., usl = 2., dl = 6.)
args2 = list(sigma = .314, lsl = 1., usl = 2., dl = 6.)
expect_identical(do.call(C_p, args1), eval(e, args1))
expect_identical(do.call(C_p, args2), eval(e, args2))
rm(e, args1, args2)

expect_error(C_pk(), 'argument "mu" is missing, with no default')
expect_error(C_pk(2.5), 'argument "sigma" is missing, with no default')
expect_error(C_pk(2.5, 1.), 'argument "lsl" is missing, with no default')
expect_error(C_pk(2.5, 1., 2.), 'argument "usl" is missing, with no default')
expect_error(C_pk(2.5, 1., 2., 3.),
             'argument "dl" is missing, with no default')

expect_error(C_pk(2.5, 1., 2., 3., 6., 7.), 'unused argument \\(7\\)')
expect_error(
  C_pk("2.5", 1., 2., 3., 6.),
  '"mu" must be a base-R numeric vector and contain no Inf values'
)

expect_error(
  C_pk(2.5, "1.", 2., 3., 6.),
  '"sigma" must be a base-R numeric vector and contain no Inf values'
)

expect_error(
  C_pk(2.5, 1., "2.", 3., 6.),
  '"lsl" must be a base-R numeric vector and contain no Inf values'
)

expect_error(
  C_pk(2.5, 1., 2., "3.", 6.),
  '"usl" must be a base-R numeric vector and contain no Inf values'
)

expect_error(
  C_pk(2.5, 1., 2., 3., "6."),
  '"dl" must be a base-R numeric vector and contain no Inf values'
)

expect_error(C_pk(2.5, 1., 2:3, 3:5, 6.),
             'All vector arguments with length >1 must be of equal length')

expect_error(C_pk(2.5, -1., 2., 3., 6.), '"sigma >= 0" is false')
expect_error(C_pk(2.5, 1., 3., 2., 6.), '"usl > lsl" is false')
expect_error(C_pk(2.5, 1., 2., 2., 6.), '"usl > lsl" is false')
expect_error(C_pk(2.5, 1., 2., 3., 0.), '"dl > 0" is false')

# Test int yields double.
expect_identical(C_pk(2.5, integer(0L), 2., 3., 6.), double(0L))

# Test NA over NaN.
expect_identical(C_pk(2.5, 1/6, NaN, 3., NA_real_), NA_real_)
expect_identical(C_pk(2.5, 1/6, NA_real_, 3., NaN), NA_real_)

expect_identical(C_pk(2.5, 1/6, 2., 3., 6.), 1.) # known output
# Output with NA's.
expect_identical(C_pk(2.5, c(NA, 1/6), 2., 3., 6.), c(NA, 1.))
# Output with NaN's.
expect_identical(C_pk(2.5, c(NaN, 1/6), 2., 3., 6.), c(NaN, 1.))

# sigma == 0 yields NaN.
expect_identical(C_pk(2.5, 0., 2., 3., 6.), NaN)
expect_identical(C_pk(2.5, c(0., 1/6), 2., 3., 6.), c(NaN, 1.))


# Assert that output won't carry names attribute.
expect_identical(C_pk(c(foo = 2.5), 1/6, 2., 3., 6.), 1.)
expect_identical(C_pk(2.5, c(foo = 1/6), 2., 3., 6.), 1.)
expect_identical(C_pk(2.5, 1/6, c(foo = 2.), 3., 6.), 1.)
expect_identical(C_pk(2.5, 1/6, 2., c(foo = 3.), 6.), 1.)
expect_identical(C_pk(2.5, 1/6, 2., 3., c(foo = 6.)), 1.)


# Test special cases.
expect_identical(C_pk(2.5, 1., 2., 3., 6.), C_p(1., 2., 3., 6.))


# Assert that the output matches that of the alternative formulation.
expect_identical(
  C_pk(2.5, 1., 2., 3., 6.),
  min(C_pl(2.5, 1., 2., 3.), C_pu(2.5, 1., 3., 3.), na.rm = FALSE)
)

expect_identical(
  C_pk(2.24, 1., 2., 3., 6.),
  min(C_pl(2.24, 1., 2., 3.), C_pu(2.24, 1., 3., 3.), na.rm = FALSE)
)


# Test pci_info$expr_r.
e = str2expression(pci_info["C_pk", "expr_r"])
args1 = list(mu = 2.5, sigma = 1/6, lsl = 2., usl = 3.,
             dl = 6.)

args2 = list(mu = 2.5, sigma = .314, lsl = 2., usl = 3.,
             dl = 6.)

expect_identical(do.call(C_pk, args1), eval(e, args1))
expect_identical(do.call(C_pk, args2), eval(e, args2))
rm(e, args1, args2)
